<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\DeviceMaster;
use App\Models\User;

class DeviceMasterPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any DeviceMaster');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('view DeviceMaster');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create DeviceMaster');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('update DeviceMaster');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('delete DeviceMaster');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any DeviceMaster');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('restore DeviceMaster');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any DeviceMaster');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('replicate DeviceMaster');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder DeviceMaster');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, DeviceMaster $devicemaster): bool
    {
        return $user->checkPermissionTo('force-delete DeviceMaster');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any DeviceMaster');
    }
}
